import base64
import math

from django.contrib import admin
from django.db import models
from django.urls import reverse

class TextFile(models.Model):
    text = models.TextField()
    edit_key = models.CharField(max_length=43)

    def get_absolute_url(self):
        pk = base64.urlsafe_b64encode(
            self.pk.to_bytes(math.ceil(self.pk.bit_length() / 8), 'big'),
        ).decode('utf-8')

        return reverse('text-file', kwargs={ 'pk': pk })

admin.site.register(TextFile)
